var groups = [];
var groupIndex = 0;
var chart;
var colorArray = ['#00ab97', '#ffd531', '#e1007b', '#81d4cb', '#ad94b9', '#f080bd', '#02a0de', '#5fc3ea',

  '#FF6633', '#ff3366', '#8733ff', '#00B3E6', '#be00e6',
  '#E6B333', '#3366E6', '#999966', '#99FF99', '#B34D4D',
  '#80B300', '#809900', '#E6B3B3', '#6680B3', '#66991A',
  '#FF99E6', '#CCFF1A', '#FF1A66', '#E6331A', '#33FFCC',
  '#66994D', '#B366CC', '#4D8000', '#B33300', '#CC80CC',
  '#66664D', '#991AFF', '#E666FF', '#4DB3FF', '#1AB399',
  '#E666B3', '#33991A', '#CC9999', '#B3B31A', '#00E680',
  '#4D8066', '#809980', '#E6FF80', '#1AFF33', '#999933',
  '#FF3380', '#CCCC00', '#66E64D', '#4D80CC', '#9900B3',
  '#E64D66', '#4DB380', '#FF4D4D', '#99E6E6', '#6666FF'];
var chartData = {
  labels: ["Ohne Arbeitsteilung", "Mit Arbeitsteilung"],
  datasets: []
};

var stage = 1;

$(document).ready(function () {

  $("#modalIntro").modal('show');


  var ctx = document.getElementById('chart').getContext('2d');
  var ctx2 = document.getElementById('resultChart').getContext('2d');
  Chart.plugins.unregister(ChartDataLabels);

  initChart();
  // Gruppe hinzufügen

  function addGroup() {
    newEntry = { name: $('#groupNameInput').val(), befAT: 0, aftAT: 0, index: groupIndex };
    if (!newEntry.name == "") {
      groups.push(newEntry);
      var newItem =
        '<div index="' + groupIndex + '" style="background-color:' + colorArray[groups.length - 1] + '" class="groupEntry animate__animated animate__fadeInRight">' +
        '<div class="row no-gutters group-title">' +
        '<div class="col-12 my-auto">' +
        '<div class="row no-gutters justify-content-between  p-2">' +
        '<div class="text-bold">' + newEntry.name + '</div>' +
        '<div>' +
        '<div index=\"' + groupIndex + '\" class="px-1 text-center text-white delGroupBtn ">' +
        '<i class="fas fa-trash"></i>' +
        '</div>' +
        '</div>' +
        '</div>' +
        '</div>' +
        '<div class="col px-2 pb-2 pt-0 before-input round active"><small>Ohne <span class="d-none d-lg-inline">Arbeitsteilung:</span></small> <input index=\"' + groupIndex + '\" min="0" value=\"' + newEntry.befAT + '\" class="form-control form-control-sm valBefAT" type="number"></div>' +
        '<div class="col px-2 pb-2 pt-0 after-input round active d-none"><small>Mit <span class="d-none d-lg-inline">Arbeitsteilung:</span></small> <input index=\"' + groupIndex + '\" min="0" value=\"' + newEntry.aftAT + '\" class="form-control form-control-sm valAftAT" type="number"></div>' +
        '</div>' +
        '</div>';
      $("#groupEntries").append(newItem);
      $('#groupNameInput').val('');

      updateChartData()
      groupIndex++;
      $("#toStage2").prop("disabled", false);
    }
  }

  $("#addGroupBtn").click(function () {
    addGroup();
  });

  $(document).on('keypress', function (e) {
    if (e.which == 13 && stage == 1) {
      addGroup();
    }
  });

  function updateChartData() {
    var initDatasets = [];
    i = 0;
    groups.forEach(function (group) {
      initDatasets.push({
        label: group.name,
        backgroundColor: colorArray[i],
        data: [groups[i].befAT, groups[i].aftAT]
      });
      i++;
    });
    chart.data.datasets = initDatasets;
    chart.update();
  }

  //Gruppe entfernen
  $('body').on('click', '.delGroupBtn', function () {
    index = $(this).attr("index");
    delIndex = -1;
    for (var i = 0; i < groups.length; i++) {
      if (groups[i].index == index) {
        delIndex = i;
        break;
      }
    };
    groups.splice(delIndex, 1);
    idx = 0;

    if (groups.length == 0) {
      $("#toStage2").prop("disabled", true);
    } else {
      $("#toStage2").prop("disabled", false);
    }
    $(".groupEntry[index='" + index + "']").remove();

    //updated die farben der einträge
    $("#groupEntries").children('.groupEntry').each(function () {
      $(this).css('background-color', colorArray[idx]);
      idx++;
    });
    updateChartData();
  });

  //Zur Gruppenübersicht
  $('body').on('click', '#toStage1', function () {
    $("#title-r1").removeClass("animate__fadeOutLeft");
    $("#title-r2").removeClass("animate__fadeInRight");
    $("#title-r2").addClass("animate__fadeOutRight");
    setTimeout(
      function () {
        $("#title-r2").addClass("d-none");
        $("#title-r1").removeClass("d-none");
        $("#title-r1").addClass("animate__fadeInLeft");
        $("#title-r2").removeClass("animate__fadeOutRight");
      }, 500);

    $(".groupEntry").each(function (index) {
      $(this).find(".before-input").toggleClass("d-none");
      $(this).find(".after-input").toggleClass("d-none");
      $(this).find(".delGroupBtn").removeClass("d-none");
    });
    $("#toStage2").removeClass("d-none");
    $("#toStage1").addClass("d-none");
    $("#toStage3").addClass("d-none");
    $("#add-group").removeClass("d-none");

    stage = 1;
    $("#modalIntro").modal('show');
  });

  //Zur zweiten Runde
  $('body').on('click', '#toStage2', function () {
    $("#title-r1").removeClass("animate__fadeInRight");
    $("#title-r1").addClass("animate__fadeOutLeft");
    setTimeout(
      function () {
        $("#title-r1").addClass("d-none");
        $("#title-r2").removeClass("d-none");
        $("#title-r2").addClass("animate__fadeInRight");
      }, 500);

    $(".groupEntry").each(function (index) {;
      $(this).find(".before-input").toggleClass("d-none");
      $(this).find(".after-input").toggleClass("d-none");
      $(this).find(".delGroupBtn").addClass("d-none");
    });
    $("#toStage2").addClass("d-none");
    $("#toStage1").removeClass("d-none");
    $("#toStage3").removeClass("d-none");
    $("#add-group").addClass("d-none");

    $("#modalRound2").modal('show');

    stage = 2;
  });

  //Zur Ergebnis Ansicht
  $('body').on('click', '#toStage3', function () {
    $("#title-r2").removeClass("animate__fadeInRight");
    $("#title-r2").addClass("animate__fadeOutLeft");
    $("#title-result").removeClass("animate__fadeOutRight");
    setTimeout(
      function () {
        $("#title-r2").addClass("d-none");
        $("#title-result").removeClass("d-none");
        $("#title-result").addClass("animate__fadeInRight");
      }, 500);
    $("#chart").addClass("d-none");
    $("#resultChart").removeClass("d-none");
    $("#backToStage2").removeClass("d-none");
    $("#toggleResult").removeClass("d-none");
    $("#toStage1").addClass("d-none");
    $("#toStage3").addClass("d-none");
    $(".groupEntry").each(function (index) {
      $(this).find(".before-input").removeClass("d-none");
    });
    initResultChart();
    stage = 3;
  });

  //Zurück Stage 2
  $('body').on('click', '#backToStage2', function () {
    $("#title-result").removeClass("animate__fadeInRight");
    $("#title-result").addClass("animate__fadeOutRight");
    $("#title-r2").removeClass("animate__fadeOutLeft");
    setTimeout(
      function () {
        $("#title-result").addClass("d-none");
        $("#title-r2").removeClass("d-none");
        $("#title-r2").addClass("animate__fadeInLeft");
      }, 500);
    $("#chart").removeClass("d-none");
    $("#resultChart").addClass("d-none");
    $("#toggleResult").addClass("d-none");
    $("#backToStage2").addClass("d-none");
    $("#toStage1").removeClass("d-none");
    $("#toStage3").removeClass("d-none");
    $(".groupEntry").each(function (index) {
      $(this).find(".before-input").addClass("d-none");
    });
    $("#modalRound2").modal('show');
    stage = 2;
  });

  //Ansicht wechseln
  $('body').on('click', '#toggleResult', function () {
    $("#chart").toggleClass("d-none");
    $("#resultChart").toggleClass("d-none");
  });

  //Eingabe verarbeitung vorher-werte
  $('body').on('change', ".valBefAT", function () {
    index = $(this).attr("index");
    for (var i = 0; i < groups.length; i++) {
      if (groups[i].index == index) {
        groups[i].befAT = $(this).val();
        break;
      }
    };
    for (var i = 0; i < groups.length; i++) {
      chart.data.datasets[i].data = [groups[i].befAT, groups[i].aftAT];
    };
    chart.update();

    if (stage == 3) {
      updateResultChart();
    }
  });

  function updateResultChart() {
    befAT = 0;
    aftAT = 0;
    groups.forEach(function (group) {
      befAT += parseInt(group.befAT);
      aftAT += parseInt(group.aftAT);
    });

    resChart.data.datasets[0].data = [befAT, aftAT];
    resChart.update();
  }


  //Eingabe verarbeitung nachher-werte
  $('body').on('change', ".valAftAT", function () {
    index = $(this).attr("index");
    for (var i = 0; i < groups.length; i++) {
      if (groups[i].index == index) {
        groups[i].aftAT = $(this).val();
        break;
      }
    };
    for (var i = 0; i < groups.length; i++) {
      chart.data.datasets[i].data = [groups[i].befAT, groups[i].aftAT];
    };
    chart.update();
    if (stage == 3) {
      updateResultChart();
    }
  });

  //Filter für Dateiname
  $("#filename").inputFilter(function (value) {
    return /^[0-9a-zA-Z_-]*$/.test(value);
  });

  function initChart() {
    var initDatasets = [];
    i = 0;
    groups.forEach(function (group) {
      initDatasets.push({
        label: group.name,
        backgroundColor: colorArray[i],
        data: [groups[i].befAT, groups[i].aftAT]
      });
      i++;
    });

    chartData.datasets = initDatasets;

    chart = new Chart(ctx, {
      // The type of chart we want to create
      type: 'horizontalBar',

      // The data for our dataset
      data: chartData,

      // Configuration options go here
      options: {
        responsive: true,
        barValueSpacing: 20,
        scales: {
          xAxes: [{
            ticks: {
              suggestedMin: 0,
              suggestedMax: 10,
              maxTicksLimit: 10
            }
          }]
        }
      }
    });
  };

  function initResultChart() {
    befAT = 0;
    aftAT = 0;
    groups.forEach(function (group) {
      befAT += parseInt(group.befAT);
      aftAT += parseInt(group.aftAT);
    });

    resChart = new Chart(ctx2, {
      type: 'doughnut',
      data: {
        labels: ["Ohne Arbeitsteilung", "Mit Arbeitsteilung"],
        datasets: [
          {
            datalabels: {
              color: '#FFF'
            },
            label: "",
            backgroundColor: ["#168def", "#5c2874"],
            data: [befAT, aftAT],
            borderColor: "#0ff0"
          }
        ]
      },
      plugins: [ChartDataLabels],
      options: {
        animation: {
          duration: 2000,
        },
        plugins: {
          // Change options for ALL labels of THIS CHART
          datalabels: {
            color: '#36A2EB'
          }
        },
        title: {
          display: true,
          text: 'Ergebnisse vor und nach der Arbeitsteilung'
        }
      }
    });
  }

  function handleFileSelect(evt) {
    var files = evt.target.files; // FileList object

    // Loop through the FileList
    for (var i = 0, f; f = files[i]; i++) {

      var reader = new FileReader();

      // Closure to capture the file information.
      reader.onload = (function (theFile) {
        return function (e) {
          groups = JSON.parse(e.target.result);
          $("#groupEntries").empty();
          idx = 0;
          groups.forEach(function (newEntry) {
            var newItem =
              '<div index="' + newEntry.index + '" style="background-color:' + colorArray[idx] + '" class="groupEntry animate__animated animate__fadeInRight">' +
              '<div class="row no-gutters group-title">' +
              '<div class="col-12 my-auto">' +
              '<div class="row no-gutters justify-content-between  p-2">' +
              '<div class="text-bold">' + newEntry.name + '</div>' +
              '<div>' +
              '<div index=\"' + newEntry.index + '\" class="px-1 text-center text-white delGroupBtn ">' +
              '<i class="fas fa-trash"></i>' +
              '</div>' +
              '</div>' +
              '</div>' +
              '</div>' +
              
              buildString(newEntry);

              +
              '</div>' +
              '</div>';
            $("#groupEntries").append(newItem);
            idx++;
          });
          groupIndex = idx;
          if (groups.length == 0) {
            $("#toStage2").prop("disabled", true);
          } else {
            $("#toStage2").prop("disabled", false);
          }
          initResultChart();
          initChart();
        };
      })(f);
      reader.readAsText(f);
    }
  }
  document.getElementById('files').addEventListener('change', handleFileSelect, false);

  function buildString(newEntry){
    string = "";
    if (stage ==1)
    {
      string = '<div class="col px-2 pb-2 pt-0 before-input round active"><small>Ohne <span class="d-none d-lg-inline">Arbeitsteilung:</span></small> <input index=\"' + newEntry.index + '\" min="0" value=\"' + newEntry.befAT + '\" class="form-control form-control-sm valBefAT" type="number"></div>' +
      '<div class="col px-2 pb-2 pt-0 after-input round active d-none"><small>Mit <span class="d-none d-lg-inline">Arbeitsteilung:</span></small> <input index=\"' + newEntry.index + '\" min="0" value=\"' + newEntry.aftAT + '\" class="form-control form-control-sm valAftAT" type="number"></div>';
    }else if(stage == 2)
    {
      string = '<div class="col px-2 pb-2 pt-0 before-input round active d-none"><small>Ohne <span class="d-none d-lg-inline">Arbeitsteilung:</span></small> <input index=\"' + newEntry.index + '\" min="0" value=\"' + newEntry.befAT + '\" class="form-control form-control-sm valBefAT" type="number"></div>' +
      '<div class="col px-2 pb-2 pt-0 after-input round active"><small>Mit <span class="d-none d-lg-inline">Arbeitsteilung:</span></small> <input index=\"' + newEntry.index + '\" min="0" value=\"' + newEntry.aftAT + '\" class="form-control form-control-sm valAftAT" type="number"></div>';
    }else if (stage == 3)
    {
      string = '<div class="col px-2 pb-2 pt-0 before-input round active"><small>Ohne <span class="d-none d-lg-inline">Arbeitsteilung:</span></small> <input index=\"' + newEntry.index + '\" min="0" value=\"' + newEntry.befAT + '\" class="form-control form-control-sm valBefAT" type="number"></div>' +
      '<div class="col px-2 pb-2 pt-0 after-input round active"><small>Mit <span class="d-none d-lg-inline">Arbeitsteilung:</span></small> <input index=\"' + newEntry.index + '\" min="0" value=\"' + newEntry.aftAT + '\" class="form-control form-control-sm valAftAT" type="number"></div>';
    }

    return string;
  }

  $("#save").click(function () {
    var content = JSON.stringify(groups);
    var filename = $("#filename").val();

    var blob = new Blob([content], {
      type: "application/json;charset=utf-8"
    });

    saveAs(blob, filename);
  });

  $("#toInput").click(function() {
    $("#modalSave").modal("hide");
    $("#modalIntro").modal("hide");
    $("#modalRound2").modal("hide");
  })

  $("#toExport").click(function() {
    $("#modalInput").modal("hide");
    $("#modalIntro").modal("hide");
    $("#modalRound2").modal("hide");
  })

});

// Restricts input for the set of matched elements to the given inputFilter function.
(function ($) {
  $.fn.inputFilter = function (inputFilter) {
    return this.on("input keydown keyup mousedown mouseup select contextmenu drop", function () {
      if (inputFilter(this.value)) {
        this.oldValue = this.value;
        this.oldSelectionStart = this.selectionStart;
        this.oldSelectionEnd = this.selectionEnd;
      } else if (this.hasOwnProperty("oldValue")) {
        this.value = this.oldValue;
        this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
      } else {
        this.value = "";
      }
    });
  };
}(jQuery));